/*
 *  By: Sunil Kumar
 *  GeoIO Module. Module to draw simple 2D geometry objects and serialization.
 *  This code is free and is distributed in the hope that it will be useful for simple learning and experimental purpose only WITHOUT any WARRANTY.
 *  The author shall hold no redistribution liability in case of any unethical usage/modification.
 *  Distributed under CPOL.
 */
// GeoLine.h: interface for the CGeoLine class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __GEOLINE_H__
#define __GEOLINE_H__

#include "stdafx.h"
#include "Primitive.h"

class GEOIO_EXPORT CGeoLine : public CPrimitive
{
	DECLARE_SERIAL(CGeoLine)
public:
	CGeoLine();
	CGeoLine(CGeoLine& pEntity);
	CGeoLine(CPoint stPnt, CPoint endPnt);
	virtual ~CGeoLine();

	void DeleteEntity();
	CPrimitive* CreateClone();
	void MirrorAboutXaxis(void);
	void MirrorAboutYaxis(void);
	BOOL IsPointNearEntity(CPoint refPnt);
	void Serialize(CArchive& ar);
	void Draw(CDC *pDC);

};

#endif // __GEOLINE_H__
