// GeoText.cpp: implementation of the CGeoText class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GeoText.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(CGeoText, CObject, VERSIONABLE_SCHEMA | GEOIO_MODULE_VERSION_NUM)

CGeoText::CGeoText()
{
	m_strText = _T("");
	SetEntityType(GEOIO_TEXT);
}

CGeoText::CGeoText(CGeoText& pEntity)
{
	SetEntityType(pEntity.GetEntityType());
	SetEntityNumber(pEntity.GetEntityNumber());
	SetStartPoint(pEntity.GetStartPoint());
	SetEndPoint(pEntity.GetEndPoint());
	SetEntityColor(pEntity.GetEntityColor());
	m_strText = pEntity.m_strText;
}

CGeoText::~CGeoText()
{
}


/***********************************************************************************
	This fuction draws the text within rect as m_StPnt as top left point and
	m_EndPnt as bottom right point. pass the DC of the view class
***********************************************************************************/
void CGeoText::Draw(CDC *pDC)
{
	CPen pen(PS_SOLID, 0, m_clr);
	pDC->SelectObject(&pen);
	pDC->SetBkMode(TRANSPARENT);
	pDC->SetTextColor(m_clr);
	pDC->TextOut(m_StPnt.x, m_StPnt.y, m_strText);
}

// store or load
void CGeoText::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{	// storing code
		ar << m_strText;
	}
	else
	{	// loading code
		ar >> m_strText;
	}

	CPrimitive::Serialize(ar);
}

/***********************************************************************************
	Function to determine if the point passed is near the entity
***********************************************************************************/
void CGeoText::PointNearEntity(CPoint pnt)
{
}

void CGeoText::DeleteEntity()
{
	SetDeleted();
}

BOOL CGeoText::IsPointNearEntity(CPoint refPnt)
{
	return TRUE;
}

/*---------------------------------------------------------------------------------
	Function to mirror entity with respect to X-axis
---------------------------------------------------------------------------------*/
void CGeoText::MirrorAboutXaxis()
{
	AfxMessageBox(_T("Operation cannot be performed..."), MB_ICONINFORMATION);
}

/*---------------------------------------------------------------------------------
	Function to mirror entity with respect to y-axis
---------------------------------------------------------------------------------*/
void CGeoText::MirrorAboutYaxis()
{
	AfxMessageBox(_T("Operation cannot be performed..."), MB_ICONINFORMATION);
}

/*---------------------------------------------------------------------------------
	Function to clone the entity. This function returns a new pointer to
	cloned entity.
---------------------------------------------------------------------------------*/
CPrimitive* CGeoText::CreateClone()
{
	CGeoText* pClone = new CGeoText(*this);
	return pClone;
}