// UndoList.cpp: implementation of the CUndoList class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "UndoList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CUndoList::CUndoList()
{

}

CUndoList::~CUndoList()
{
	// delete all the entities in the undo list //
	while( !m_Undolist.IsEmpty() )
	{
		CPrimitive *pEntity = m_Undolist.GetHead();
		m_Undolist.RemoveHead();
		delete pEntity;
		pEntity = NULL;
	}
	// finally clear the list //
	m_Undolist.RemoveAll();
}

/****************************************************************************
	This function gets the last item in the undo list
****************************************************************************/
CPrimitive* CUndoList::GetLastItem()
{
	POSITION pos = m_Undolist.GetHeadPosition();
	if( pos == NULL )
		return NULL;

	CPrimitive *pEntity = NULL ;
	POSITION prev = NULL;
	while( pos != NULL )
	{
		prev = pos;
		pEntity = (CPrimitive *)m_Undolist.GetNext(pos);
		ASSERT(pEntity);
	}

	if( pEntity != NULL )
		m_Undolist.RemoveAt(prev);
	return pEntity;
}

/****************************************************************************
	This function adds the item to the undo list
****************************************************************************/
void CUndoList::AddToUndoList(CPrimitive *pEntity)
{
	m_Undolist.AddTail(pEntity);
}

/**********************************************************************************
 this function is used to delete undo list
**********************************************************************************/
void CUndoList::ClearUndoList()
{
	if( m_Undolist.GetCount() > 0)
	while( m_Undolist.IsEmpty() == FALSE )
		delete m_Undolist.RemoveHead();
}

/**********************************************************************************
  Function to get the entity count present in the undo list
**********************************************************************************/
int CUndoList::GetCount()
{
	return ( m_Undolist.GetCount() );
}

/****************************************************************************
	This function deletes the entity whose entity number is passed as
	parameter
****************************************************************************/
void CUndoList::DeleteEntity(int nEntityNum)
{
	POSITION pos = m_Undolist.GetHeadPosition();
	if( pos == NULL )
		return ;

	POSITION prev = NULL;
	CPrimitive *pEntity = NULL ;
	pEntity = (CPrimitive *)m_Undolist.GetAt(pos);
	while( pos )
	{	
		prev = pos;
		pEntity = (CPrimitive *)m_Undolist.GetNext(pos);
		ASSERT(pEntity);

		if( pEntity->GetEntityNumber() == nEntityNum )
		{
			m_Undolist.RemoveAt(prev);
			return;
		}
		
	}
}