/*
 *  By: Sunil Kumar
 *  GeoIO Module. Module to draw simple 2D geometry objects and serialization.
 *  This code is free and is distributed in the hope that it will be useful for simple learning and experimental purpose only WITHOUT any WARRANTY.
 *  The author shall hold no redistribution liability in case of any unethical usage/modification.
 *  Distributed under CPOL.
 */
// UndoList.h: interface for the CUndoList class.
//
//////////////////////////////////////////////////////////////////////
#ifndef __UNDOLIST_H__
#define __UNDOLIST_H__

#include "stdafx.h"
#include "Primitive.h"

class GEOIO_EXPORT CUndoList  
{
public:
	void DeleteEntity(int nEntityNum);
	int GetCount();
	void ClearUndoList();
	void AddToUndoList(CPrimitive *pEntity);
	CPrimitive* GetLastItem();
	CUndoList();
	virtual ~CUndoList();
private:
	CTypedPtrList<CObList, CPrimitive*>m_Undolist;
};
#endif // __UNDOLIST_H__